#define NEEDS_RNG
#include "../common/stm32wrapper.h"
#include "aes.h"
#include <stdio.h>
#include <string.h>

int main(void)
{
    clock_setup();
    gpio_setup();
    usart_setup(115200);
    flash_setup();

    SCS_DEMCR |= SCS_DEMCR_TRCENA;
    DWT_CTRL |= DWT_CTRL_CYCCNTENA;
    RNG_CR |= RNG_CR_RNGEN;
    DWT_CYCCNT = 0;
    
    int oldcount, newcount;
    char buffer[100];
    uint32_t rkeys[121];
    unsigned char key[16];
    unsigned char ctext[32];

    // Test vector
    unsigned char ptext[32] = {
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff
    };
    for(int i = 0; i< 16; i++)
        key[i] = i;
    
    oldcount = DWT_CYCCNT;
    aes128_keyschedule_sfs(rkeys, key, key);
    newcount = DWT_CYCCNT-oldcount;
    sprintf(buffer, "cyc aes128_keyschedule_sfs:%d", newcount);
    
    oldcount = DWT_CYCCNT;
    aes128_encrypt_sfs(ctext, ctext+16, ptext, ptext+16, rkeys);
    newcount = DWT_CYCCNT-oldcount;
    sprintf(buffer, "cyc aes128_encrypt_sfs:%d", newcount);
    send_USART_str(buffer);

    return 0;
}
