#include "../common/stm32wrapper.h"
#include "aes.h"
#include <stdio.h>
#include <string.h>

int main(void) {
    clock_setup();
    gpio_setup();
    usart_setup(115200);
    flash_setup();

    SCS_DEMCR |= SCS_DEMCR_TRCENA;
    DWT_CYCCNT = 0;
    DWT_CTRL |= DWT_CTRL_CYCCNTENA;
    
    int oldcount, newcount;
    char buffer[100];
    uint32_t rkey[480];
    unsigned char key[32];

    for(int i = 0; i< 32 ;i++)
        key[i] = i;

    // Values for test vector
    unsigned char ctext_8blocks[128];
    unsigned char ptext_8blocks[128] = {
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff
    };

    oldcount = DWT_CYCCNT;
    aes128_keyschedule_lut(rkey, key);
    newcount = DWT_CYCCNT-oldcount;
    sprintf(buffer, "cyc aes128_keyschedule_lut: %d", newcount);
    send_USART_str(buffer);
    
    oldcount = DWT_CYCCNT;
    aes128_encrypt(ctext_8blocks, rkey, ptext_8blocks);
    newcount = DWT_CYCCNT-oldcount;
    sprintf(buffer, "cyc aes128_encrypt: %d", newcount);
    send_USART_str(buffer);
    
    oldcount = DWT_CYCCNT;
    aes256_keyschedule_lut(rkey, key);
    newcount = DWT_CYCCNT-oldcount;
    sprintf(buffer, "cyc aes256_keyschedule_lut: %d", newcount);
    send_USART_str(buffer);
    
    oldcount = DWT_CYCCNT;
    aes256_encrypt(ctext_8blocks, rkey, ptext_8blocks);
    newcount = DWT_CYCCNT-oldcount;
    sprintf(buffer, "cyc aes256_encrypt: %d", newcount);
    send_USART_str(buffer);
    
    return 0;
}
