#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "util.h"
#include "aes.h"

int main(void) {
    uint64_t oldcount, newcount;
    uint8_t out[128];
    uint8_t key[32];
    uint32_t rkeys[480];

    // Test vector
    uint8_t in[128] = {
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff
    };
    for(int i = 0; i < 32; i++)
        key[i] = i;
    
    for(int i = 0; i < 10; i++) {
        oldcount = getcycles();
        aes128_encrypt(out, in, rkeys);
        newcount = getcycles()-oldcount;
    }
    printf("cyc aes128_encrypt: %d\n", (unsigned int)newcount);

    for(int i = 0; i < 10; i++) {
        oldcount = getcycles();
        aes256_encrypt(out, in, rkeys);
        newcount = getcycles()-oldcount;
    }
    printf("cyc aes256_encrypt: %d\n", (unsigned int)newcount);
    
    return 0;
}

