#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "util.h"
#include "aes.h"

int main(void) {
    uint8_t out[32], key[32];
    uint64_t oldcount, cyclecount;
    uint8_t in[32] = {
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
        0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
        0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff
    };
    for(int i = 0; i < 32; i++)
        key[i] = i;
   
    uint32_t rkey_ffs[120];

    // AES-128 semi-fixsliced
    printf("--- AES-128 semi-fixsliced ---\n");
  //   for(int i = 0; i< 10; i++) {
  //       oldcount = getcycles();
		// aes128_keyschedule_sfs_lut(rkey_ffs, key);
  //       cyclecount = getcycles()-oldcount;
  //   }
  //   printf("cyc aes128_keyschedule_sfs_lut: %d\n", (unsigned int)cyclecount);
    for(int i = 0; i< 10; i++) {
        oldcount = getcycles();
		aes128_keyschedule_sfs(rkey_ffs, key, key);
        cyclecount = getcycles()-oldcount;
    }
    printf("cyc aes128_keyschedule_sfs: %d\n", (unsigned int)cyclecount);
    for(int i = 0; i< 10; i++) {
        oldcount = getcycles();
        aes128_encrypt_sfs(out, out+16, in, in+16, rkey_ffs);
        cyclecount = getcycles()-oldcount;
    }
    printf("cyc aes128_encrypt_sfs: %d\n", (unsigned int)cyclecount);

    // AES-256 semi-fixsliced
    printf("--- AES-256 semi-fixsliced ---\n");
  //   for(int i = 0; i< 10; i++) {
  //       oldcount = getcycles();
		// aes256_keyschedule_sfs_lut(rkey_ffs, key);
  //       cyclecount = getcycles()-oldcount;
  //   }
  //   printf("cyc aes256_keyschedule_sfs_lut: %d\n", (unsigned int)cyclecount);
    for(int i = 0; i< 10; i++) {
        oldcount = getcycles();
		aes256_keyschedule_sfs(rkey_ffs, key, key);
        cyclecount = getcycles()-oldcount;
    }
    printf("cyc aes256_keyschedule_sfs: %d\n", (unsigned int)cyclecount);
    for(int i = 0; i< 10; i++) {
        oldcount = getcycles();
        aes256_encrypt_sfs(out, out+16, in, in+16, rkey_ffs);
        cyclecount = getcycles()-oldcount;
    }
    printf("cyc aes256_encrypt_sfs: %d\n", (unsigned int)cyclecount);

    // AES-128 fully-fixsliced
    printf("--- AES-128 fully-fixsliced ---\n");
    // for(int i = 0; i< 10; i++) {
    //     oldcount = getcycles();
    //     aes128_keyschedule_ffs_lut(rkey_ffs, key);
    //     cyclecount = getcycles()-oldcount;
    // }
    // printf("cyc aes128_keyschedule_ffs_lut: %d\n", (unsigned int)cyclecount);
    for(int i = 0; i< 10; i++) {
        oldcount = getcycles();
        aes128_keyschedule_ffs(rkey_ffs, key, key);
        cyclecount = getcycles()-oldcount;
    }
    printf("cyc aes128_keyschedule_ffs: %d\n", (unsigned int)cyclecount);
    for(int i = 0; i< 10; i++) {
        oldcount = getcycles();
        aes128_encrypt_ffs(out, out+16, in, in+16, rkey_ffs);
        cyclecount = getcycles()-oldcount;
    }
    printf("cyc aes128_encrypt_ffs: %d\n", (unsigned int)cyclecount);

    // AES-256 fully-fixsliced
    printf("--- AES-256 fully-fixsliced ---\n");
    // for(int i = 0; i< 10; i++) {
    //     oldcount = getcycles();
    //     aes256_keyschedule_ffs_lut(rkey_ffs, key);
    //     cyclecount = getcycles()-oldcount;
    // }
    // printf("cyc aes256_keyschedule_ffs_lut: %d\n", (unsigned int)cyclecount);
    for(int i = 0; i< 10; i++) {
        oldcount = getcycles();
        aes256_keyschedule_ffs(rkey_ffs, key, key);
        cyclecount = getcycles()-oldcount;
    }
    printf("cyc aes256_keyschedule_ffs: %d\n", (unsigned int)cyclecount);
    for(int i = 0; i< 10; i++) {
        oldcount = getcycles();
        aes128_encrypt_ffs(out, out+16, in, in+16, rkey_ffs);
        cyclecount = getcycles()-oldcount;
    }
    printf("cyc aes256_encrypt_ffs: %d\n", (unsigned int)cyclecount);

    return 0;
}

